/**
 * 
 */
package sim.graphics;

import sim.exception.SRuntimeException;

/**
 * Interface reprsentant un raytracer permettant de gnrer des images 2D  partir d'une description d'un environnement 3D.
 * @author Simon Vzina
 * @since 2015-04-07
 * @version 2015-04-07
 */
public interface SRaytracer {

  /**
   * Mthode pour effectuer le calcul du raytracing pour l'ensemble des pixels d'un viewport
   *  l'aide d'une description gomtrique d'un environnement 3D.
   */
  public void raytrace();
  
  /**
   * Mthode pour effectuer le raytracing de la scne sur un nombre limit de pixels du viewport.
   * @param nb_pixel - Le nombre de pixels  calculer. Si le nombre est suprieur aux pixels disponibles, ils seronts tous calculs.
   * @throws SRuntimeException Si le nombre de pixels  calculer est ngatif.
   */
  public void raytrace(int nb_pixel) throws SRuntimeException;
 
  /**
   * Mthode pour obtenir le nombre total de pixels  calculer.
   * @return Le nombre de pixels  calculer.
   */
  public int nbPixels();
  
}//fin interface SRaytracer
